/********************************** (C) COPYRIGHT *******************************
 * File Name          : net_config.c
 * Author             : WCH
 * Version            : V1.10
 * Date               : 2022/04/28
 * Description        : net
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/
#ifndef __NET_CONFIG_H__
#define __NET_CONFIG_H__

#ifdef __cplusplus
extern "C" {
#endif

/*********************************************************************
 * socketãIPRAW + UDP + TCP + TCP_LISTEN = socket 
 */
#define WCHNET_NUM_IPRAW              0  /* IPRAWӵĸ */

#define WCHNET_NUM_UDP                2  /* UDPӵĸ */

#define WCHNET_NUM_TCP                1  /* TCPӵĸ */

#define WCHNET_NUM_TCP_LISTEN         0  /* TCP */

/* Socketĸ31  */
#define WCHNET_MAX_SOCKET_NUM    (WCHNET_NUM_IPRAW+WCHNET_NUM_UDP+WCHNET_NUM_TCP+WCHNET_NUM_TCP_LISTEN)

#define WCHNET_TCP_MSS                536  /* TCP MSSĴС*/

/*********************************************************************
 * MAC
 */
#define ETH_TXBUFNB                   2    /* MAC  */

#define ETH_RXBUFNB                   4    /* MAC  */

#ifndef ETH_MAX_PACKET_SIZE
#define ETH_RX_BUF_SZE                1520  /* MACջȣΪ4 */
#define ETH_TX_BUF_SZE                1520  /* MACͻȣΪ4 */
#else
#define ETH_RX_BUF_SZE                ETH_MAX_PACKET_SIZE
#define ETH_TX_BUF_SZE                ETH_MAX_PACKET_SIZE
#endif

/*********************************************************************
  *  
 */
#define WCHNET_PING_ENABLE            1    /* PINGʹܣĬPING */

#define TCP_RETRY_COUNT               20   /* TCPشĬֵ20 */

#define TCP_RETRY_PERIOD              10   /* TCPشڣĬֵ10 λ50ms */

#define SOCKET_SEND_RETRY             1    /* ʧã1ã0 */

#define CFG0_TCP_SEND_COPY            1    /* TCPͻƣ1ƣ0 */

#define CFG0_TCP_RECV_COPY            1    /* TCPոŻڲʹ */

#define CFG0_TCP_OLD_DELETE           0    /* ɾTCPӣ1ã0 */

/*********************************************************************
  *  ڴ
 */
/*If a single socket cannot reach full speed,
 * try to increase RECE_BUF_LEN to (WCHNET_TCP_MSS*4)
 * and increase WCHNET_NUM_TCP_SEG to (WCHNET_NUM_TCP*4)*/
#define RECE_BUF_LEN                  (WCHNET_TCP_MSS*2)   /* socket receive buffer size */

#define WCHNET_NUM_PBUF               (WCHNET_MAX_SOCKET_NUM+WCHNET_NUM_TCP)   /* Number of PBUF structures */

#define WCHNET_NUM_TCP_SEG            (WCHNET_NUM_TCP*2)   /* The number of TCP segments used to send */

#define WCHNET_MEM_HEAP_SIZE          (((WCHNET_TCP_MSS+0x10+54)*WCHNET_NUM_TCP_SEG)+ETH_TX_BUF_SZE+64) /* memory heap size */

#define WCHNET_NUM_ARP_TABLE          50   /* Number of ARP lists */

#define WCHNET_NUM_IP_REASSDATA       4    /* Number of IP segments */

#define CFG0_IP_REASS_PBUFS           4    /* Number of reassembled IP PBUFs  */

#define WCHNET_MEM_ALIGNMENT          4    /* 4 byte alignment */

#define WCHNET_NUM_POOL_BUF           (WCHNET_NUM_TCP*2+2)   /* The number of POOL BUFs, the number of receive queues */

/* Check the configuration of the SOCKET quantity */
#if( WCHNET_NUM_TCP_LISTEN && !WCHNET_NUM_TCP )
  #error "WCHNET_NUM_TCP Error)"
#endif
/* ֽڶΪ4 */
#if((WCHNET_MEM_ALIGNMENT % 4) || (WCHNET_MEM_ALIGNMENT == 0))
  #error "WCHNET_MEM_ALIGNMENT Error,Please Config WCHNET_MEM_ALIGNMENT = 4 * N, N >=1"
#endif
/* TCPĶγ */
#if((WCHNET_TCP_MSS > 1460) || (WCHNET_TCP_MSS < 60))
  #error "WCHNET_TCP_MSS Error,Please Config WCHNET_TCP_MSS >= 60 && WCHNET_TCP_MSS <= 1460"
#endif
/* ARP */
#if((WCHNET_NUM_ARP_TABLE > 0X7F) || (WCHNET_NUM_ARP_TABLE < 1))
  #error "WCHNET_NUM_ARP_TABLE Error,Please Config WCHNET_NUM_ARP_TABLE >= 1 && WCHNET_NUM_ARP_TABLE <= 0X7F"
#endif
/* POOL BUF */
#if(WCHNET_NUM_POOL_BUF < 1)
  #error "WCHNET_NUM_POOL_BUF Error,Please Config WCHNET_NUM_POOL_BUF >= 1"
#endif
/* PBUFṹ */
#if(WCHNET_NUM_PBUF < 1)
  #error "WCHNET_NUM_PBUF Error,Please Config WCHNET_NUM_PBUF >= 1"
#endif
/* IP */
#if((WCHNET_NUM_IP_REASSDATA > 10) || (WCHNET_NUM_IP_REASSDATA < 1))
  #error "WCHNET_NUM_IP_REASSDATA Error,Please Config WCHNET_NUM_IP_REASSDATA < 10 && WCHNET_NUM_IP_REASSDATA >= 1 "
#endif
/* IPƬС */
#if(WCHNET_IP_REASS_PBUFS > WCHNET_NUM_POOL_BUF)
  #error "WCHNET_IP_REASS_PBUFS Error,Please Config WCHNET_IP_REASS_PBUFS < WCHNET_NUM_POOL_BUF"
#endif

#if(WCHNETTIMERPERIOD > 50)
  #error "WCHNETTIMERPERIOD Error,Please Config WCHNETTIMERPERIOD < 50"
#endif

/* ֵ0 */
#define WCHNET_MISC_CONFIG0    (((CFG0_TCP_SEND_COPY) << 0) |\
                               ((CFG0_TCP_RECV_COPY)  << 1) |\
                               ((CFG0_TCP_OLD_DELETE) << 2) |\
                               ((CFG0_IP_REASS_PBUFS) << 3) )
/* ֵ1 */
#define WCHNET_MISC_CONFIG1    (((WCHNET_MAX_SOCKET_NUM)<<0)|\
                               ((WCHNET_PING_ENABLE) << 13) |\
                               ((TCP_RETRY_COUNT)    << 14) |\
                               ((TCP_RETRY_PERIOD)   << 19) |\
                               ((SOCKET_SEND_RETRY)  << 25) )

#ifdef __cplusplus
}
#endif
#endif
