/********************************** (C) COPYRIGHT *******************************
 * File Name          : CH57x_clk.h
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2022/12/05
 * Description        : 
 ********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

#ifndef __CH57x_CLK_H__
#define __CH57x_CLK_H__

#ifdef __cplusplus
 extern "C" {
#endif

#include "CH579SFR.h"
#include "core_cm0.h"
#include <stdbool.h>

typedef enum
{
	CLK_SOURCE_LSI = 0,
	CLK_SOURCE_LSE,
	CLK_SOURCE_HSE_32MHz,
	CLK_SOURCE_HSE_16MHz,
	CLK_SOURCE_HSE_8MHz,
	CLK_SOURCE_HSI_32MHz,				//ÉÏµçÄ¬ÈÏÇé¿ö	
	CLK_SOURCE_HSI_16MHz,
	CLK_SOURCE_HSI_8MHz,
	CLK_SOURCE_PLL_40MHz,
	CLK_SOURCE_PLL_32MHz,
	CLK_SOURCE_PLL_24MHz,
	CLK_SOURCE_PLL_20MHz,
	CLK_SOURCE_PLL_16MHz,
	
}SYS_CLKTypeDef;


typedef enum
{
	Clk32M_HSI = 0,
	Clk32M_HSE,
	
}HClk32MTypeDef;

typedef enum
{
	Clk32K_LSI = 0,
	Clk32K_LSE,
	
}LClk32KTypeDef;

typedef enum
{
	HSE_RCur_75 = 0,
	HSE_RCur_100,
    HSE_RCur_125,
    HSE_RCur_150
	
}HSECurrentTypeDef;

typedef enum
{
	HSECap_10p = 0,
	HSECap_12p,  HSECap_14p,  HSECap_16p,  HSECap_18p,  
    HSECap_20p,  HSECap_22p,  HSECap_24p
	
}HSECapTypeDef;

typedef enum
{
	LSE_RCur_70 = 0,
	LSE_RCur_100,
    LSE_RCur_140,
    LSE_RCur_200
	
}LSECurrentTypeDef;

typedef enum
{
	LSECap_2p = 0,
	LSECap_13p,  LSECap_14p,  LSECap_15p,  LSECap_16p,  
    LSECap_17p,  LSECap_18p,  LSECap_19p,  LSECap_20p,
    LSECap_21p,  LSECap_22p,  LSECap_23p,  LSECap_24p,
    LSECap_25p,  LSECap_26p,  LSECap_27p
	
}LSECapTypeDef;

#define  MAX_DAY		0x00004000 
#define	 MAX_2_SEC		0x0000A8C0
//#define	 MAX_SEC		0x545FFFFF	

#define BEGYEAR													2020
#define	IsLeapYear(yr)									(!((yr) % 400) || (((yr) % 100) && !((yr) % 4)))
#define	YearLength(yr)									(IsLeapYear(yr) ? 366 : 365)
#define monthLength(lpyr,mon)						(((mon)==1) ? (28+(lpyr)) : (((mon)>6) ? (((mon)&1)?31:30) : (((mon)&1)?30:31)))

/**
  * @brief  rtc timer mode period define
  */
typedef enum
{
	Period_0_125_S = 0,			// 0.125s ÖÜÆÚ
	Period_0_25_S,				// 0.25s ÖÜÆÚ
	Period_0_5_S,				// 0.5s ÖÜÆÚ
	Period_1_S,					// 1s ÖÜÆÚ
	Period_2_S,					// 2s ÖÜÆÚ
	Period_4_S,					// 4s ÖÜÆÚ
	Period_8_S,					// 8s ÖÜÆÚ
	Period_16_S,				// 16s ÖÜÆÚ
}RTC_TMRCycTypeDef;	 
	 

/**
  * @brief  rtc interrupt event define
  */
typedef enum
{
	RTC_TRIG_EVENT = 0,			// RTC ´¥·¢ÊÂ¼þ
	RTC_TMR_EVENT,				// RTC ÖÜÆÚ¶¨Ê±ÊÂ¼þ

}RTC_EVENTTypeDef;	 

/**
  * @brief  rtc interrupt event define
  */
typedef enum
{
	RTC_TRIG_MODE = 0,			// RTC ´¥·¢Ä£Ê½
	RTC_TMR_MODE,				// RTC ÖÜÆÚ¶¨Ê±Ä£Ê½

}RTC_MODETypeDef;

__STATIC_INLINE bool SYS_IsClkXT32MPon(void)
{
	return (R8_HFCK_PWR_CTRL & RB_CLK_XT32M_PON) ? true : false;
}

__STATIC_INLINE bool SYS_IsClkINT32MPon(void)
{
	return (R8_HFCK_PWR_CTRL & RB_CLK_INT32M_PON) ? true : false;
}

__STATIC_INLINE bool SYS_IsPLLPon(void)
{
	return (R8_HFCK_PWR_CTRL & RB_CLK_PLL_PON) ? true : false;
}

__STATIC_INLINE bool SYS_IsClkXT32MPon(void);
__STATIC_INLINE bool SYS_IsClkINT32MPon(void);
__STATIC_INLINE bool SYS_IsPLLPon(void);
void SYS_ClkXT32MPon(void);
void SYS_ClkINT32MPon(void);
void SYS_PLLPon(void);

void SystemInit(void);							/* ÏµÍ³Ê±ÖÓ³õÊ¼»¯ */	 
void SetSysClock( SYS_CLKTypeDef sc);			/* ÖØÉèÏµÍ³ÔËÐÐÊ±ÖÓ */
UINT32 GetSysClock( void );						/* »ñÈ¡µ±Ç°ÏµÍ³Ê±ÖÓ */	
void HClk32M_Select( HClk32MTypeDef hc);		/* 32M ¸ßÆµÊ±ÖÓÀ´Ô´ */
void LClk32k_Power(LClk32KTypeDef hc, bool enable);		/* 32K µÍÆµÕñµ´Æ÷µçÔ´¿ØÖÆ */
void LClk32K_Select( LClk32KTypeDef hc);		/* 32K µÍÆµÊ±ÖÓÀ´Ô´ */

void HSECFG_Current( HSECurrentTypeDef c );     /* HSE¾§Ìå Æ«ÖÃµçÁ÷ÅäÖÃ */
void HSECFG_Capacitance( HSECapTypeDef c );     /* HSE¾§Ìå ¸ºÔØµçÈÝÅäÖÃ */
void LSECFG_Current( LSECurrentTypeDef c );     /* LSE¾§Ìå Æ«ÖÃµçÁ÷ÅäÖÃ */
void LSECFG_Capacitance( LSECapTypeDef c );     /* LSE¾§Ìå ¸ºÔØµçÈÝÅäÖÃ */

UINT16 Calibration_LSI( void );				/* Íâ²¿32MÊ±ÖÓÐ£×¼ÄÚ²¿32KÊ±ÖÓ */

	 
void RTC_InitTime( UINT16 y, UINT16 mon, UINT16 d, UINT16 h, UINT16 m, UINT16 s );			/* RTCÊ±ÖÓ³õÊ¼»¯µ±Ç°Ê±¼ä */
void RTC_GetTime( PUINT16 py, PUINT16 pmon, PUINT16 pd, PUINT16 ph, PUINT16 pm, PUINT16 ps );		/* »ñÈ¡µ±Ç°Ê±¼ä */
	 
void RTC_SetCycle32k( UINT32 cyc );							/* »ùÓÚLSE/LSIÊ±ÖÓ£¬ÅäÖÃµ±Ç°RTC ÖÜÆÚÊý */	 
UINT32 RTC_GetCycle32k( void );				                /* »ùÓÚLSE/LSIÊ±ÖÓ£¬»ñÈ¡µ±Ç°RTC ÖÜÆÚÊý */

void RTC_TRIGFunCfg( UINT32 cyc );							/* RTC´¥·¢Ä£Ê½ÅäÖÃ¼ä¸ôÊ±¼ä,»ùÓÚLSE/LSIÊ±ÖÓ£¬Æ¥ÅäÖÜÆÚÊý */
void RTC_TMRFunCfg( RTC_TMRCycTypeDef t );					/* RTC¶¨Ê±Ä£Ê½ÅäÖÃ */
void RTC_ModeFunDisable( RTC_MODETypeDef m );               /* RTC Ä£Ê½¹¦ÄÜ¹Ø±Õ */

UINT8 RTC_GetITFlag( RTC_EVENTTypeDef f );					/* »ñÈ¡RTCÖÐ¶Ï±êÖ¾ */	 
void RTC_ClearITFlag( RTC_EVENTTypeDef f );					/* Çå³ýRTCÖÐ¶Ï±êÖ¾ */ 

	 

	 
#ifdef __cplusplus
}
#endif

#endif  // __CH57x_CLK_H__	

