/* 
 * IocHub Demo for WeChat    
 *
 * Copyright (C) 2004 - 2023 Nanjing Qinheng Microelectronics Co., Ltd.
 * Web:      http://wch.cn
 * Author:   WCH <tech@wch.cn>
 * Version:  V1.1
 *
 */ 

const app = getApp()
const IoCLib = require('../../utils/IoCHubWxLib.js');

Page({
  data: {
    tcpSocket:null,
    btnType:1,
    btnText:"自动发送",
    sendValue:'',  
    

    reciveData:null,          //tcpSocket.onMessage()接收到的数据
    dstDeviceUkStr:'',    //目标设备唯一标识
    sendDataCountMap: {},     //
    clientB_ID:"",    //要通信的设备标识
    registerLoginBtnText:"启动服务",    //连接鉴权按钮文字
    registerLoginFlag:false,    //连接鉴权成功标志
    openSessionBtnText:"打开会话",    //打开会话按钮文字
    uniqueKey:null,   //唯一标识
    random_8:null,     //8位长度的随机数
    deviceIDArray:null, //设备标识数组
    deviceIDString:null,    //设备标识字符串
    registerLoginResult:"",     //连接鉴权时展示的信息
    registerLoginTime:"0ms",    //连接鉴权用时
    openSessionTime:"0ms",      //打开会话用时
    TCPReciveLength:'0B',       //接收数据大小
    TCPReciveSpeed:"0B/S",      //接收数据速度
    TCPReciveData:"", //接收到的数据
    TCPSendLength:'0B',         //发送数据大小
    TCPSendSpeed:"0B/S",        //发送数据速度
    TCPSendData:"",     //要发送的数据
    timestamp1:0,               
    timestamp2:0,                
    timestamp3:0,               
    timestamp4:0,                
    data2Send:"",         //要发送的数据
    reciveDataFromB:0,         //从B接收的数据长度
    broadcastBtnText:"局域网扫描",
    computeDataSend:"",




    registerInfo:"本机标识：",
    broadcastAddressAndUKArray:[],           //广播存储地址、端口和标识
    selectUdpDevice:"",
    selectedUdpDeviceIndex:0,
    clientBInfo:{},
    receiveTimer:null,                      //接收数据定时器，定时取数据
    receiveData:"",
    broadcastTimer:null,                     //广播定时器
    connectionsArray:[],
    exitsConnections:0,
    opensessionTimer:null,
    isShowCfgBox:false,
    receiveBufferSize:null,            //接收缓冲区长度
    timeout:null,                       //操作超时时间，默认10s  
    maxConnections:null,                        //最大连接数  
    autoBtnText:"自动发送",
    autoTimer:null,
    selectToSendText:"选择发送",
    selectToSendTimer:null,
    select_computeData:"",
    timestamp5:0,               
    timestamp6:0,  
    autoBtnDisabled:true,
    selectSendBtnDisabled:true,
    onClickSendBtnDisabled:true,
    networkTimer:null,
    selectToSendFlag:false,
    autoSendFlag:false,
    loginSuccessFlag:false,
    computeDataAutoSend:"",
    currentNetworkType:null,
    connectionViewTimer:null,
    sendBufferSize:null,
    selectedOpenStateIndex:0,
    openStateArray:[
      {
        state:0,
        label:'公开'
      },
      {
        state:1,
        label:'受限'
      },
      {
        state:2,
        label:'私有'
      },
    ],
    selectOpenState:'公开',
    modeType:0,        //当前开放状态：0（完全开放）、1（半开放）、0（完全不开放）
    accountPassLoginBtnText:'账号登录',
    isShowLoginBox:false,
    login_DeviceID:"",
    login_DevicePass:"",
    grantServerAddress:"",
    connectCode:"",         //要连接的对端验证码
    clientAUk:'',
  },

  onLoad: function() {
    this.handleWrite();
    var yzCode = wx.getStorageSync('sessionKey')
    this.setData({
      yzCode:yzCode
    })
    this.data.yzCode = yzCode
    app.globalData.pageName = this;
    app.closeSession();
    app.showConnect();
  },
  onUnload:function(){
    //清除取数据的定时器
    if(this.data.receiveTimer){
      clearInterval(this.data.receiveTimer)
      this.data.receiveTimer = null
    }

    //清除广播定时器
    if(this.data.broadcastTimer){
      clearInterval(this.data.broadcastTimer)
      this.data.broadcastTimer = null
    }

    if(this.data.opensessionTimer){
      clearInterval(this.data.opensessionTimer)
      this.data.opensessionTimer = null
    }

    if(this.data.networkTimer){
      clearInterval(this.data.networkTimer)
      this.data.networkTimer = null
    }

    clearInterval(this.data.connectionViewTimer)
    this.data.connectionViewTimer = null
  },
  //生成验证密钥
  getYzCode(){
    var yzCode = this.randomString(8)
    wx.setStorageSync('sessionKey', yzCode)
    this.setData({
      yzCode:yzCode
    })
    this.data.yzCode = yzCode
  },

  /**
   * 显示配置页面
   */
  showCfgBox(){
    this.setData({
      isShowCfgBox:true
    })
    this.data.isShowCfgBox = true
  },

  /**
   * 显示开放状态页面
   */
  showOpenBox(){
    var that = this
    var state = 0
    IoCLib.IoCHub_GetAccessMode().then(res=>{
      if(res.code == 0){
        state = res.data.modeType
        this.setData({
          isShowOpenBox:true,
          selectOpenState:this.data.openStateArray[state].label
        })
        this.data.isShowOpenBox = true
      }
    })
  },

  /**
   * 显示账户密码登录页面
   */
  showLoginBox(){
    if(this.data.registerLoginBtnText == '停止服务'){
      this.handleLogin()
    }else{
      this.setData({
        isShowLoginBox:true
      })
      this.data.isShowLoginBox = true
    }
  },

  /**
   * 选择开放状态
   */
  handleSelectOpenState(e){
    this.data.selectedOpenStateIndex = e.detail.value
    var target = this.data.openStateArray[this.data.selectedOpenStateIndex].label
    this.setData({
      selectOpenState: target,
    })
  },

  /**
   * 隐藏配置页面
   */
  hideModalInit(){
    this.setData({
      isShowCfgBox:false,
      sendBufferSize:this.data.sendBufferSize,
      receiveBufferSize:this.data.receiveBufferSize,
      maxConnections:this.data.maxConnections,
    })
    this.data.isShowCfgBox = false
  },

    /**
   * 隐藏开放状态页面
   */
  hideOpenBox(){
    this.setData({
      isShowOpenBox:false,
    })
    this.data.isShowOpenBox = false
  },

  hideLoginBox(){
    this.setData({
      isShowLoginBox:false,
    })
    this.data.isShowLoginBox = false
  },

  /**
   * 
   * 获取配置项值
   */
  inputInit0(e){
    this.setData({
      sendBufferSize:e.detail.value,
    })
    this.data.sendBufferSize = e.detail.value
  },

    /**
   * 
   * 获取配置项值
   */
  inputInit1(e){
    this.setData({
      receiveBufferSize:e.detail.value,
    })
    this.data.receiveBufferSize = e.detail.value
  },

  /**
   * 
   * 获取配置项值
   */
  inputInit2(e){
    this.setData({
      timeout:e.detail.value,
    })
    this.data.timeout = e.detail.value
  },
  
  /**
   * 
   * 获取配置项值
   */
  inputInit3(e){
    this.setData({
      maxConnections:e.detail.value,
    })
    this.data.maxConnections = e.detail.value
  },

  /**
   * 
   * 获取服务地址
   */
  getServerAddress(e){
    this.setData({
      grantServerAddress:e.detail.value,
    })
    this.data.grantServerAddress = e.detail.value
  },

  /**
   * 获取登录账户
   * @param {} e 
   */
  getDeviceID(e){
    this.setData({
      login_DeviceID:e.detail.value,
    })
    this.data.login_DeviceID = e.detail.value
  },

    /**
   * 获取登录密码
   * @param {} e 
   */
  getDevicePass(e){
    this.setData({
      login_DevicePass:e.detail.value,
    })
    this.data.login_DevicePass = e.detail.value
  },

  /**
   * 初始化全局配置
   */
  submitInitConfig(){
    var config = {
      sendBufferSize:this.data.sendBufferSize,
      receiveBufferSize:this.data.receiveBufferSize,
      maxConnections:this.data.maxConnections
    }
    IoCLib.IoCHub_SetCfg(config).then(result=>{
      if(result.code == 0){
        this.setData({
          sendBufferSize:result.data.sendBufferSize,
          receiveBufferSize:result.data.receiveBufferSize,
          maxConnections:result.data.maxConnections,
        })
      }else{
        this.setData({
          sendBufferSize:null,
          receiveBufferSize:null,
          maxConnections:null,
        })
      }
        wx.showToast({
          title: result.message,
          icon:"none"
        })
    })
    this.hideModalInit()
  },

    /**
   * 设置开放状态
   */
  submitOpenState(){
    this.data.modeType = this.data.selectedOpenStateIndex;
    this.setData({
      isShowOpenBox:false
    })
    IoCLib.IoCHub_SetAccessMode(this.data.modeType,this.data.yzCode).then(res=>{
      if(res.code == 0){
        wx.showToast({
          title: '设置成功',
          icon:'none'
        })
      }else{
        wx.showToast({
          title: '设置失败',
          icon:'none'
        })
      }
    })
  },

  /**
   * 连接鉴权
   */
  handleLogin(){
    var that = this;
    // var account = this.data.login_DeviceID ? this.data.login_DeviceID : null
    // var password = this.data.login_DevicePass ? this.data.login_DevicePass : null
    // var address = this.data.grantServerAddress ? this.data.grantServerAddress : null
    var account = null
    var password =  null
    var address =  null
    if(that.data.registerLoginBtnText == '停止服务'){
      if(that.data.opensessionTimer){
        clearInterval(that.data.opensessionTimer)
        that.data.opensessionTimer = null
      }
      if(that.data.networkTimer){
        clearInterval(that.data.networkTimer)
        that.data.networkTimer = null
      }
      if(that.data.autoTimer){
        clearInterval(that.data.autoTimer)
        that.data.autoTimer = null
      }
      //断开所有已连接的会话
      if(this.data.connectionsArray && this.data.connectionsArray.length > 0){
        for(let k = 0;k<this.data.connectionsArray.length;k++){
          IoCLib.Session_Close(this.data.clientAUk,this.data.connectionsArray[k].UK).then(result=>{

          })
        }
      }
      //停止服务
      IoCLib.IoCHub_Stop();
      //重置页面显示
      that.setData({
        cfgDisabled:false,
        registerLoginBtnText:"启动服务",
        registerInfo:"本机标识:",
        clientAUk:'',
        autoBtnDisabled:true,
        selectSendBtnDisabled:true,
        onClickSendBtnDisabled:true,
        connectionsArray:[],
        exitsConnections:0,
        openSessionBtnText:"打开会话",
        clientUk:"",
        connectCode:"",
      })
      that.loginSuccessFlag = false;
    }else{
      IoCLib.IoCHub_Start(account,password,address).then(result=>{
        if(result.code == 0 || result.code == 101){
          that.setData({
            cfgDisabled:true,
            registerLoginBtnText:"停止服务",
            registerInfo:"本机标识:" + result.data,
            clientAUk:result.data.replace(/\s*/g,"")
          })
          that.loginSuccessFlag = true;
          that.data.opensessionTimer =  setInterval(()=>{
            that.getSessionResult()
          },1000)
          that.data.networkTimer =  setInterval(()=>{
            IoCLib.IoCHub_GetCurrentNetworkType().then(result=>{
              var networkType = result.data.networkType
              if(networkType  == 'none'){
                wx.showToast({
                  title: '网络异常',
                  icon:"none"
                })
              }else{
                if(that.data.currentNetworkType == null || that.data.currentNetworkType == ""){
                  that.data.currentNetworkType = networkType
                }else{
                    if(networkType != null && that.data.currentNetworkType != networkType){          //当前网络发生变化
                      wx.showToast({
                        title: '网络环境变化',
                        icon:"none"
                      })
                      that.data.currentNetworkType = networkType
                    }
                }
              }
            })
          },2000)
        }else if(result.code == 102 || result.code == 103 || result.code == 104 || result.code == 105){
          that.setData({
            registerLoginBtnText:"启动服务",
            registerInfo:result.message
          })
          that.loginSuccessFlag = false;
        }else{
          that.loginSuccessFlag = false;
        }
      }).catch(err=>{
        that.setData({
          registerLoginBtnText:"启动服务",
          registerInfo:err.message
        })
      })
    }
    this.hideLoginBox()
  },

  /**
   * 广播
   */
  handleBroadcast(){
    var that = this;
    if(this.data.broadcastBtnText == '局域网扫描'){
      setTimeout(()=>{
        clearInterval(that.data.broadcastTimer)
        that.data.broadcastTimer = null
  
        that.setData({
          broadcastBtnText:"局域网扫描"
        })
      },5000)
      IoCLib.IoCHub_GetLocalID().then(res1=>{
        if(res1 && res1.code == 0){
          if(res1.data && res1.data.localID){
            that.setData({
              registerInfo:"本机标识:" + res1.data.localID
            })
            this.data.broadcastTimer = setInterval(()=>{
              IoCLib.IoCHub_ScanLocalDevice().then(result=>{
                if(result.code != null && result.code == 0){
                  that.setData({
                    broadcastAddressAndUKArray:result.data.broadcastAddressAndUKArray
                  })
                  // that.data.clientBInfo = result.data.broadcastAddressAndUKArray
                }else if(result.code != null && result.code != 0){
                  wx.showToast({
                    title: result.message,
                    icon:"none"
                  })
                }
              }).catch(err=>{
                
              })
            },3000)
          }else{
            wx.showToast({
              title: "客户端UK不存在",
              icon:"none"
            })
            that.setData({
              registerInfo:"本机标识:"
            })
          }
        }
      })

      this.setData({
        broadcastBtnText:"停止扫描"
      })
    }else{
      clearInterval(that.data.broadcastTimer)
      that.data.broadcastTimer = null

      that.setData({
        broadcastBtnText:"局域网扫描"
      })
    }
  },

  /**
   * 广播：局域网连接客户端
   */
  udpOpensession(e){
/*     if(this.data.connectCode == '' || this.data.connectCode.length == 0){
      wx.showToast({
        title: '密钥不能为空',
        icon:'none'
      })
      return;
    } */
    var that = this;
    this.data.selectedUdpDeviceIndex = e.detail.value
    var target = this.data.broadcastAddressAndUKArray[this.data.selectedUdpDeviceIndex].UK
    this.setData({
      selectUdpDevice: target,
    })
    this.data.clientB_ID = target
    this.data.clientBInfo = this.data.broadcastAddressAndUKArray[this.data.selectedUdpDeviceIndex]
    setTimeout(()=>{
      IoCLib.Session_Open(this.data.clientBInfo.UK,this.data.connectCode).then(result=>{
        if(result.code != null && result.code == 0){
          wx.showToast({
            title: "打开会话",
            icon:'none',
            duration:2000
          })
          that.setData({
            openSessionBtnText:"关闭会话",
            clientUk:that.data.clientBInfo.UK.toLowerCase()
          })
        }else if(result.code != null && result.code != 0){
          wx.showToast({
            title:"打开会话失败",
            icon:'none',
            duration:2000
          })
          that.setData({
            openSessionBtnText:"打开会话"
          })
        }
      })
    },4000)
  },

  /**
   * 打开会话
   */
  openSession(){
    var that = this;
    if(that.data.openSessionBtnText =='关闭会话'){
      this.setData({
        openSessionBtnText:"打开会话",
        clientUk:"",
        selectUdpDevice:"",
        connectCode:""
      })
      IoCLib.Session_Close(this.data.clientAUk,this.data.clientB_ID);
      this.getConnections();
      this.data.clientB_ID = "";
      this.data.clientBInfo = {};
      this.data.receiveData = "";

      if(that.data.autoTimer){
        clearInterval(that.data.autoTimer)
        that.data.autoTimer = null
      }
      return 
    }

    if(!that.loginSuccessFlag){
      wx.showToast({
        title: '当前设备未登陆',
        icon:'none'
      })
      return;
    }
    if(this.data.clientB_ID == '' || this.data.clientB_ID.length == 0){
      wx.showToast({
        title: '设备标识不能为空',
        icon:'none'
      })
      return;
    }else if(this.data.clientB_ID.length != 16){
      wx.showToast({
        title: '设备标识格式不正确',
        icon:'none'
      })
      return 
    }

/*     if(this.data.connectCode == '' || this.data.connectCode.length == 0){
      wx.showToast({
        title: '密钥不能为空',
        icon:'none'
      })
      return;
    } */
    
    this.data.clientBInfo = {
      ip:"",
      port:"",
      UK:this.data.clientB_ID
    }
    console.log('UK:',this.data.clientBInfo.UK,'connectCode:',this.data.connectCode)
    IoCLib.Session_Open(this.data.clientBInfo.UK,this.data.connectCode).then(result=>{
      if(result.code == 0){
        wx.showToast({
          title: "会话打开成功",
          icon:'none',
          duration:2000
        })
        that.setData({
          openSessionBtnText:"关闭会话"
        })
        that.getConnections()
      }else{
        wx.showToast({
          title:"打开会话失败",
          icon:'none',
          duration:2000
        })
        that.setData({
          openSessionBtnText:"打开会话"
        })
      }
    });
  },
  /**
   * 对端发送断开会话指令
   */
  closeSession(clientB_ID){
    if (clientB_ID) {
      IoCLib.Session_Close(this.data.clientAUk,clientB_ID).then(result=>{
        if(result && result.code == 0){
          this.getConnections()
          wx.showToast({
            title: clientB_ID.toUpperCase() + "\n会话断开",
            icon:'none',
            duration:2000
          })
        }
      })
    }
  },
  /**
   * 获取所有已连接
   */
  getConnections(){
    var that = this;
    var connectionsArray = [];
    var flag = false
    var index = 0
    IoCLib.IoCHub_GetAllSessions().then(result=>{
      if(result.code == 0){
        var session_Map = result.data.sessionMap;
        if(result.data.sessionMap.size == 0){
          that.setData({
            autoBtnDisabled:true,
            selectSendBtnDisabled:true,
            onClickSendBtnDisabled:true,
            connectionsArray:[],
            exitsConnections:0
          })
          return;
        }
        session_Map.forEach(function (value, key, map) {
          flag = false
          for (let i = 0; i < that.data.connectionsArray.length; i++) {
            if (that.data.connectionsArray[i].UK == key) {
              flag = true
              index = i
              break
            }
          }
          if (flag) {
            connectionsArray.push({
              UK:that.data.connectionsArray[index].UK,
              ip:that.data.connectionsArray[index].ip,
              port:that.data.connectionsArray[index].port,
              sendBuf:that.data.connectionsArray[index].sendBuf,
              sendL:that.data.connectionsArray[index].sendL,
              sendV:"0B/S",
              receBuf:that.data.connectionsArray[index].receBuf,
              receBuf_1:that.data.connectionsArray[index].receBuf_1,
              count:that.data.connectionsArray[index].count,
              receL:that.data.connectionsArray[index].receL,
              receV:"0B/S"
            })
          } else {
            connectionsArray.push({
              UK:key,
              ip:value['ip'],
              port:value['port'],
              sendBuf:"",
              sendL:"",
              sendV:"0B/S",
              receBuf:"",
              receBuf_1:"",
              count:0,
              receL:"",
              receV:"0B/S"
            })
          }
        })
        if(result.data.sessionMap && result.data.sessionMap.size > 0){
          that.setData({
            autoBtnDisabled:false,
            onClickSendBtnDisabled:false,
            connectionsArray:connectionsArray,
            exitsConnections:connectionsArray.length
          })
        }
      }
    })
    if(! this.data.connectionViewTimer ||  this.data.connectionViewTimer == null){
      this.data.connectionViewTimer = setInterval(()=>{
        that.setData({
          connectionsArray:that.data.connectionsArray,
        })
      },1000)
    }
  },

  /**
   * 监听打开会话结果
   */
  getSessionResult(){
    var that = this;
    IoCLib.IoCHub_GetSessionResult().then(result=>{
      if(result.code == 0){
        // wx.showToast({
        //   title: '打开会话',
        //   icon:"none"
        // })
        // this.setData({
        //   openSessionBtnText:"关闭会话",
        //   clientUk:result.data.UK.toUpperCase()
        // })
        this.data.clientBInfo = {
          ip:"",
          port:"",
          UK:result.data.UK.toUpperCase()
        }
        clearInterval(that.data.opensessionTimer)
        that.data.opensessionTimer = null
      }else if(result.code && result.code != 0){
        wx.showToast({
          title: result.message,
          icon:"none"
        })
      }
    })
  },

  /**
   * 
   * 选择设备
   */
  selectDevice(obj){
    this.data.selectedFlag = true;
    this.setData({
      selectSendBtnDisabled:false,
    })
    this.data.clientBInfo = {
      ip:obj.currentTarget.dataset.type.ip,
      port:obj.currentTarget.dataset.type.port,
      UK:obj.currentTarget.dataset.type.UK
    }
    wx.showToast({
      title: '选中设备',
      icon:'none'
    })
  },

  handleSendData(clientBInfo,data2Send){
    var that = this;
    var buf = this.string2ArrayBuffer(data2Send)
    IoCLib.Session_Write(clientBInfo.UK,buf).then(res=>{
      if(res.code == 0){
        //处理写入缓冲区的结果
        if(this.data.connectionsArray && this.data.connectionsArray.length >0){
          for(var j=0;j<this.data.connectionsArray.length;j++){
            that.data.timestamp4 =new Date().getTime();
            var useTime = ((that.data.timestamp4 - that.data.timestamp3) / 1000);
            if(this.data.connectionsArray[j]['UK'] == clientBInfo.UK){
              this.data.connectionsArray[j]['sendBuf'] += this.data.data2Send
              this.data.connectionsArray[j]['sendL'] = that.data.connectionsArray[j]['sendBuf'].length
              this.data.connectionsArray[j]['sendV'] = that.convertSpeed(this.data.connectionsArray[j]['sendL'],useTime)
            }
          }
        }
      }else if(res.code == -1 || res.code == 401 || res.code == 505){
        wx.showToast({
          title: res.message,
          icon:"none"
        })
        if(this.data.selectToSendTimer){
          clearInterval(this.data.selectToSendTimer)
          this.data.selectToSendTimer = null
        }
        if(this.data.connectionsArray && this.data.connectionsArray.length >0){
          for(var m=0;m<this.data.connectionsArray.length;m++){
            if(this.data.connectionsArray[m]['UK'] == clientBInfo.UK){
              this.data.connectionsArray[m]['sendV'] = '0B/S'
            }
          }
        }
      }
      //处理发送数据的结果
      var result = res.data.get(clientBInfo.UK).sendBufferResult
      if(result && result.code && result.code == 505){
        wx.showToast({
          title: result.message,
          icon:"none"
        })
        /* if(this.data.selectToSendTimer){
          clearInterval(this.data.selectToSendTimer)
          this.data.selectToSendTimer = null
        }
        this.selectToSend() */
      }
    }).catch(error=>{
      wx.showToast({
        title: "Socket通道异常",
        icon:"none"
      })
    })
  },

  /**
   * 选择设备发送数据
   */
  selectToSend(){
    var that = this;
    if(!this.data.data2Send || this.data.data2Send == ''){
      wx.showToast({
        title: '请输入要发送的数据',
        icon:'none'
      })
      return;
    }
    if(this.data.connectionsArray && this.data.connectionsArray.length > 0){
      if(this.data.selectedFlag){ //先选择设备
        if(this.data.selectToSendText == '选择发送'){
          this.setData({
            autoBtnDisabled:true,
            onClickSendBtnDisabled:true,
            selectToSendText:"停止"
          })
          this.data.select_computeData = "";
          this.data.selectToSendFlag = true;
          if(!this.data.timestamp3 || this.data.timestamp3 == 0){
            this.data.timestamp3 = new Date().getTime();
          }
          if(!this.data.selectToSendTimer){
            that.data.selectToSendTimer = setInterval(()=>{
              this.handleSendData(this.data.clientBInfo,this.data.data2Send)
            },10)
          }
        }else{
          this.setData({
            selectToSendText:"选择发送",
            autoBtnDisabled:false,
            onClickSendBtnDisabled:false,
          })
          this.data.select_computeData = ""
          this.data.selectToSendText == '选择发送'
          setTimeout(()=>{
            this.data.selectToSendFlag = false;
            for(var k=0;k<this.data.connectionsArray.length;k++){
              if(this.data.connectionsArray[k]['UK'] == this.data.clientBInfo.UK){
                this.data.connectionsArray[k]['sendV'] = "0B/S"
              }
            }
            that.setData({
              connectionsArray:this.data.connectionsArray,
            })
          },500)
          if(this.data.selectToSendTimer){
            clearInterval(this.data.selectToSendTimer)
            this.data.selectToSendTimer = null
          }
        }
      }
    }
  },

  isShowReceive(e){
    var flag = e.detail.value.length > 0
    if(flag){
      this.setData({
        TCPReciveData:this.data.receiveData
      })
    }else{
      this.data.receiveData = ""
      this.setData({
        TCPReciveData:""
      })
    }
  },
  
  /**
   * 发送数据
   */
  onClickSend(){
    var that = this;
    this.data.TCPSendData += this.data.data2Send
    if(!this.data.data2Send || this.data.data2Send == ''){
      return;
    }
    var buf = this.string2ArrayBuffer(this.data.data2Send)
    IoCLib.Session_Write(this.data.clientBInfo.UK,buf).then(res=>{
      var result = res.get(that.data.clientBInfo.UK).sendBufferResult
      var sendTimes = res.get(that.data.clientBInfo.UK).sendTimes;
      if(result && result.code ==0){
        for(var j=0;j<this.data.connectionsArray.length;j++){
          this.data.select_computeData += this.data.data2Send
          if(this.data.connectionsArray[j]['UK'] == this.data.clientBInfo.UK){
            this.data.connectionsArray[j]['sendBuf'] += this.data.data2Send
            this.data.connectionsArray[j]['sendL'] = this.data.connectionsArray[j]['sendBuf'].length
            if(sendTimes){
              // this.data.connectionsArray[j]['sendL'] = this.data.data2Send.length * sendTimes
            }
          }
          that.setData({
            connectionsArray:this.data.connectionsArray,
          })
        }
      }
    })
  },

  
  /**
   * 取数据
   */
  handleWrite(){
    var RecvLen = 1024 * 10;
    this.data.receiveTimer = setInterval(()=>{
      if(this.data.connectionsArray && this.data.connectionsArray.length >0){
        for(var i=0;i<this.data.connectionsArray.length;i++){
          this.getReceiveBuffer(this.data.connectionsArray[i].UK,RecvLen)
        }
      }
    },100)
  },

  getReceiveBuffer(UK,RecvLen){
    var that = this;
    if(UK){
      IoCLib.Session_Read(UK,RecvLen).then(res=>{
        if(res.size > 0){
          var result = res.get(UK).receiveBufferResult
          if(result && result.code != null){
            if(result.code == 0 && result.data && result.data.buffer && result.data.buffer.length > 0){
              for(var j=0;j<that.data.connectionsArray.length;j++){
                if(that.data.connectionsArray[j]['UK'] == UK){
                  var receB = that.ab2str(result.data.buffer);
                  that.data.connectionsArray[j]['receBuf'] = receB
                  var receB_1 = that.data.connectionsArray[j]['receBuf_1']
                  that.data.connectionsArray[j]['receL'] = that.data.connectionsArray[j]['receBuf'].length
                  that.data.connectionsArray[j]['count'] += 1
                  if (that.data.connectionsArray[j]['count'] == 10) {
                    that.data.connectionsArray[j]['receV'] = that.convertSpeed(receB.length - receB_1.length,1)
                    that.data.connectionsArray[j]['receBuf_1'] = receB
                    that.data.connectionsArray[j]['count'] = 0
                  }
                }
              }
            }else if(result.code == 0 && (!result.data || result.data.buffer || result.data.buffer.length == 0)){
              for(var k=0;k<that.data.connectionsArray.length;k++){
                that.data.connectionsArray[k]['receV'] = '0B/S'
              }
            }else if(result.code != 0){
              wx.showToast({
                title:result.message,
                icon:'none',
                duration:2000
              })
            }
          } 
        }
      })
    }
  },

  /**
   * 自动发送
   */
  autoSend(){
    var that = this;
    if(!this.data.data2Send || this.data.data2Send == ''){
      wx.showToast({
        title: '请输入要发送的数据',
        icon:'none'
      })
      return;
    }
    if(!this.data.timestamp5 || this.data.timestamp5 == 0){
      this.data.timestamp5 = new Date().getTime();
    }
    if(this.data.autoBtnText == '自动发送'){
      this.setData({
        selectSendBtnDisabled:true,
        onClickSendBtnDisabled:true,
        autoBtnText:"停止"
      })
      if(this.data.connectionsArray && this.data.connectionsArray.length >0){
        that.data.autoTimer = setInterval(()=>{
          for(var j=0;j<this.data.connectionsArray.length;j++){
            var clientBInfo = {
              ip:this.data.connectionsArray[j]['ip'],
              port:this.data.connectionsArray[j]['port'],
              UK:this.data.connectionsArray[j]['UK'],
            }
            this.handleSendData2(clientBInfo,this.data.data2Send)
          }
        },15)
      }
    }else{
      IoCLib.Send_Stop()
      this.setData({
        autoBtnText:"自动发送",
        onClickSendBtnDisabled:false,
      })
      if(this.data.selectedFlag){
        this.setData({
          selectSendBtnDisabled:false,
        })
      }
      setTimeout(()=>{
        for(var k=0;k<this.data.connectionsArray.length;k++){
          this.data.connectionsArray[k]['sendV'] = "0B/S"
        }
        that.setData({
          connectionsArray:this.data.connectionsArray,
        })
      },500)
      if(this.data.autoTimer){
        clearInterval(this.data.autoTimer)
        this.data.autoTimer = null
      }
    }
  },

  handleSendData2(clientBInfo,data2Send){
    var that = this;
    var buf = this.string2ArrayBuffer(data2Send)
    IoCLib.Session_Write(clientBInfo.UK,buf).then(res=>{
      if(res.code == 0){
        //处理写入缓冲区的结果
        if(this.data.connectionsArray && this.data.connectionsArray.length >0){
          for(var j=0;j<this.data.connectionsArray.length;j++){
            this.data.select_computeData += this.data.data2Send
            that.data.timestamp6 = new Date().getTime();
            var useTime = ((that.data.timestamp6 - that.data.timestamp5) / 1000);
            if(this.data.connectionsArray[j]['UK'] == clientBInfo.UK){
              this.data.connectionsArray[j]['sendBuf'] += this.data.data2Send
              this.data.connectionsArray[j]['sendL'] = that.data.connectionsArray[j]['sendBuf'].length
              this.data.connectionsArray[j]['sendV'] = that.convertSpeed(this.data.connectionsArray[j]['sendL'],useTime)
            }
          }
        }
      }
      if(res.code == -1 || res.code == 401 || res.code == 505){
        wx.showToast({
          title: res.message,
          icon:"none"
        })
        if(this.data.autoTimer){
          clearInterval(this.data.autoTimer)
          this.data.autoTimer = null
        }
        if(this.data.connectionsArray && this.data.connectionsArray.length >0){
          for(var m=0;m<this.data.connectionsArray.length;m++){
            if(this.data.connectionsArray[m]['UK'] == clientBInfo.UK){
              this.data.connectionsArray[m]['sendV'] = '0B/S'
            }
          }
        }
      }
      //处理发送数据的结果
      var result = res.data.get(clientBInfo.UK).sendBufferResult
      if(result && result.code && result.code == 505){
        wx.showToast({
          title: result.message,
          icon:"none"
        })
/*         if(this.data.autoTimer){
          clearInterval(this.data.autoTimer)
          this.data.autoTimer = null
        }
        if(this.data.connectionsArray && this.data.connectionsArray.length >0){
          that.data.autoTimer = setInterval(()=>{
            for(var j=0;j<this.data.connectionsArray.length;j++){
              var clientBInfo = {
                ip:this.data.connectionsArray[j]['ip'],
                port:this.data.connectionsArray[j]['port'],
                UK:this.data.connectionsArray[j]['UK'],
              }
              this.handleSendData2(clientBInfo,this.data.data2Send)
            }
          },10)
        } */
      }
    }).catch(error=>{
      wx.showToast({
        title: "Socket通道异常",
        icon:"none"
      })
    })
  },

  /**
   * 
   * 关闭会话
   */
  handleCloseSession(obj){
    if(this.data.autoBtnText=='停止' || !this.data.selectToSendText=='停止'){
      wx.showToast({
        title: '请先停止发送数据，再关闭连接',
        icon:"none"
      })
      return;
    }
    IoCLib.Session_Close(this.data.clientAUk,obj.currentTarget.dataset.type.UK).then(result=>{
      if(result && result.code == 0){
        this.getConnections()
      }
    })
  },

  /**
   * 
   * 重置清空
   */
  handleReset(obj){
    var UK = obj.currentTarget.dataset.type.UK;
    this.data.select_computeData = "";
    if(this.data.connectionsArray && this.data.connectionsArray.length > 0){
      for(var i=0;i<this.data.connectionsArray.length;i++){
        if(this.data.connectionsArray[i]['UK'] = UK){
          this.data.connectionsArray[i]['sendBuf'] = ""
          this.data.connectionsArray[i]['receBuf'] = ""
          this.data.connectionsArray[i]['receBuf_1'] = ""
          this.data.connectionsArray[i]['count'] = 0
          this.data.connectionsArray[i]['sendL'] = '0B'
          this.data.connectionsArray[i]['receL'] = '0B'
          this.data.connectionsArray[i]['sendV'] = '0B/S'
          this.data.connectionsArray[i]['receV'] = '0B/S'
        }
      }
      this.setData({
        connectionsArray:this.data.connectionsArray,
      })
    }
  },

  /**
   * 关闭TCP Socket
   */
  closeTCPSocket(){
    IoCLib.IoCHub_Stop()
    this.setData({
      clientUk:""
    })
  },





  //获取对端标识
  getClientBID(e){
    this.data.clientB_ID = e.detail.value;
  },
  //获取连接密钥
  getConnectCode(e){
    this.data.connectCode = e.detail.value;
  },
  //获取要发送的数据
  getData2Send(e){
    this.data.data2Send = e.detail.value;
  },
  handleResetSendValue(){
    this.setData({
      data2Send:""
    })
  },

  /**
   * arraybuffer转十进制字符串
   * @param {*} arrayBuffer 
   */
  ab2str(arrayBuffer) {
    let unit8Arr = new Uint8Array(arrayBuffer) ;
    let encodedString = String.fromCharCode.apply(null, unit8Arr)
    return encodedString
  },

    /**
     * B、KB、MB、GB转换
     * @param {*} limit 
     */
  convertSize(limit){
      var size = "";  
      if( limit < 1 * 1024 ){ //如果小于0.1KB转化成B  
          size = limit.toFixed(0) + "B";    
      }else if(limit < 1 * 1024 * 1024 ){//如果小于0.1MB转化成KB  
          size = (limit / 1024).toFixed(1) + "KB";              
      }else if(limit < 1 * 1024 * 1024 * 1024){ //如果小于0.1GB转化成MB  
          size = (limit / (1024 * 1024)).toFixed(1) + "MB";  
      }else{ //其他转化成GB  
          size = (limit / (1024 * 1024 * 1024)).toFixed(1) + "GB";  
      }  
      return size
  },

  /**
   * B/S、KB/S、MB/S、GB/S转换
   * @param {*} limit 
   */
  convertSpeed(size,useTime){
      var speed = (size / useTime);  
      var newSpeed = "";
      if( speed < 1 * 1024 ){ //如果小于1KB/S转化成B/S
          newSpeed = speed.toFixed(0) + "B/S";    
      }else if(speed < 1 * 1024 * 1024 ){//如果小于1MB/S转化成KB/S
          newSpeed = (speed / 1024).toFixed(1) + "KB/S";              
      }else if(speed < 1 * 1024 * 1024 * 1024){ //如果小于1GB/S转化成MB/S 
          newSpeed = (speed / (1024 * 1024)).toFixed(1) + "MB/S";  
      }else{ //其他转化成GB/S
          newSpeed = (speed / (1024 * 1024 * 1024)).toFixed(1) + "GB/S";  
      }  
      return newSpeed
  },

    /**         private 27
     * 将字符串转换Unit8Array并返回
     * @param {*} str 要转换的字符串
     */
    string2ArrayBuffer(str){
      // var buf = new ArrayBuffer(str.length); 
      var bufView = new Uint8Array(str.length);
      for (var i = 0, strLen = str.length; i < strLen; i++) {
      bufView[i] = str.charCodeAt(i);
      }
      return bufView;
  },

  /**
   * 生成指定长度的随机字符串
   * @param {*} n 生成字符串的长度
   */
  randomString(n) {  
    let str = 'abcdefghijklmnopqrstuvwxyz9876543210';
    let tmp = '',
        i = 0,
        l = str.length;
    for (i = 0; i < n; i++) {
      tmp += str.charAt(Math.floor(Math.random() * l));
    }
    return tmp;
  }
})