﻿// 2023.01
//*******************************************
//**  Copyright  (C)  WCH  2004-2023       **
//**  Web:  http://wch.cn                  **
//*******************************************
//**     iochub library demo for Windwos   **
//*******************************************
//
// IoCHub接口库 V1.1
// 南京沁恒微电子
// IoCHub  V1.1
// 运行环境: Windows
// 

// WCHIOTTestDlg.cpp : 实现文件
//

#include "stdafx.h"
#include "WCHIOTTest.h"
#include "WCHIOTTestDlg.h"
#include "iphlpapi.h"
#pragma comment(lib,"iphlpapi.lib")

#include "IoCHubDLL.h"
#pragma comment(lib,"IoCHubDLL.lib")


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CWnd* MainCwnd = NULL;
int ConnectHandle = -1;
DWORD WINAPI RecvThread(LPVOID lpparam);
int g_OnlineStatus = 0;
bool g_IsSending = FALSE;
unsigned long long g_RecvNum = 0;
unsigned long long g_SendNum = 0;
int g_RecvSpeed = 0;
int g_SendSpeed = 0;
int g_InterTime = 0;
bool g_ShowData = TRUE;
IOCHUB_INIT_CFG_T g_IotCfg;
char g_PCIP[16] = { 0 };		//当前IP
char g_LocalID[17] = { 0 };		//LocalID
bool g_Synchronization = TRUE;
HANDLE g_SaveFile = NULL;
bool g_SaveFileF = FALSE;
long long g_SaveLen = 0;



VOID  DbgPrint(LPCTSTR lpFormat, ...)
{
	CHAR TextBufferTmp[5120] = "";

	va_list arglist;
	va_start(arglist, lpFormat);
	vsprintf(&TextBufferTmp[strlen(TextBufferTmp)], lpFormat, arglist);
	va_end(arglist);

	OutputDebugString(TextBufferTmp);
	SendDlgItemMessage(MainCwnd->m_hWnd, IDC_EDIT_RECVDATA, EM_SETSEL, 0xFFFFFFFE, 0xFFFFFFFE);
	SendDlgItemMessage(MainCwnd->m_hWnd, IDC_EDIT_RECVDATA, EM_REPLACESEL, 0, (LPARAM)TextBufferTmp);
	SendDlgItemMessage(MainCwnd->m_hWnd, IDC_EDIT_RECVDATA, EM_SETSEL, 0xFFFFFFFE, 0xFFFFFFFE);

	return;
}

/**
 * 扫描回调
		  */
VOID pScanCallBack(LAN_SCAN_RESULT_T* pLanDevNodes, int nodeSize)
{
	char TransBuf[100] = "", CopyBuf[17] = "";
	CWCHIOTTestDlg* pDlg = (CWCHIOTTestDlg*)MainCwnd;

	for (int i = 0; i < nodeSize; ++i) {
		memset(CopyBuf, 0, sizeof(CopyBuf));
		memcpy(CopyBuf, pLanDevNodes[i].nodeID, 16);
		sprintf(TransBuf, "%s", CopyBuf);
		pDlg->m_combo_scandev.AddString(TransBuf);
	}
	pDlg->m_combo_scandev.SetCurSel(0);

}

/**
 * 事件回调
		  */
VOID pIochubEventCallBack(int eventCode, void* eventData)
{
	char TransBuf[20] = "", TempBuf[20] = "";
	int IDLen = 16;

	switch (eventCode) {
	case EVENT_RELAY_START:// 启动服务
		DbgPrint("启动服务成功\r\n");
		if (!g_Synchronization) {
			char CfgFilePath[200] = "", CfgData[17] = "";
			FILE* CfgFile = NULL;
			//Sleep(5000);
			if (IoCHub_GetLocalID(g_LocalID, &IDLen) == 0) {
				MainCwnd->SetDlgItemText(IDC_EDIT_LOCALUK, g_LocalID);
			}
			MainCwnd->SetDlgItemText(IDC_BUTTON_LOGIN, "停止服务");
			g_OnlineStatus = 1;
			if (IoCHub_GetNATType() == 0x00) {
				DbgPrint("本机网络类型为:非对称网络\r\n");
			}
			else {
				DbgPrint("本机网络类型为:对称网络\r\n");
			}
			MainCwnd->GetDlgItem(IDC_BUTTON_LOGIN)->EnableWindow(TRUE);
		}
		break;
	case EVENT_RELAY_STOP:// 停止服务
		MainCwnd->MessageBox("服务停止!");
		MainCwnd->SetDlgItemText(IDC_BUTTON_LOGIN, "启动服务");
		g_OnlineStatus = 0;
		break;
	case EVENT_ACTIVE_SESSION_OPEN:// 主动打开会话
		MainCwnd->MessageBox("会话已打开!");
		break;
	case EVENT_UNACTIVE_SESSION_OPEN:// 被动打开会话
		ConnectHandle = ((session_event_t*)eventData)->sessionFd;
		CloseHandle(CreateThread(NULL, 0, RecvThread, NULL, 0, NULL)); //创建通信线程
		memcpy(TempBuf, ((session_event_t*)eventData)->peerNodeIdStr, 16);
		sprintf(TransBuf, "%s", TempBuf);
		MainCwnd->SetDlgItemText(IDC_EDIT_CONNECTUK, TransBuf);
		MainCwnd->SetDlgItemText(IDC_BUTTON_CONNECT, "关闭会话");
		break;
	case EVENT_SESSION_READ_NOTIFY:// 会话读通知
		break;
	case EVENT_SESSION_CLOSE:// 会话关闭
		ConnectHandle = -1;
		sprintf(TransBuf, "DEVID:%s 设备已断开", (char*)eventData);
		MainCwnd->SetDlgItemText(IDC_BUTTON_CONNECT, "打开会话");
		break;
	case EVENT_SESSION_TRANSFER_TYPE_CHANGE:// 会话通信模式变化
		MainCwnd->MessageBox("会话通信模式变化!");
		break;
	case EVENT_SESSION_EXCEPTION:// 会话异常
		MainCwnd->MessageBox("会话异常!");
		break;
	case EVENT_OPERATION_ERR:// IOCHUB错误异常
		sprintf(TransBuf, "IOCHUB错误异常, 错误码%d!", ((service_event_t*)eventData)->errCo);
		MainCwnd->MessageBox(TransBuf);
		break;
	}
}

// 用于应用程序“关于”菜单项的 CAboutDlg 对话框

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// 对话框数据
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 支持

// 实现
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CWCHIOTTestDlg 对话框




CWCHIOTTestDlg::CWCHIOTTestDlg(CWnd* pParent /*=NULL                */)
	: CDialog(CWCHIOTTestDlg::IDD, pParent)
	, m_edit_send(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	MainCwnd = (CWnd*)this;
}

void CWCHIOTTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_SENDDATA, m_edit_send);
	DDX_Control(pDX, IDC_COMBO_SCANDEV, m_combo_scandev);
	DDX_Control(pDX, IDC_COMBO_AUTHORIty, m_combo_jurisdiction);
}

BEGIN_MESSAGE_MAP(CWCHIOTTestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_LOGIN, &CWCHIOTTestDlg::OnBnClickedButtonLogin)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, &CWCHIOTTestDlg::OnBnClickedButtonConnect)
	ON_BN_CLICKED(IDC_BUTTON_SEND, &CWCHIOTTestDlg::OnBnClickedButtonSend)
	ON_BN_CLICKED(IDC_BUTTON_CLRRECV, &CWCHIOTTestDlg::OnBnClickedButtonClrrecv)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_NOTSHOWDATA, &CWCHIOTTestDlg::OnBnClickedCheckNotshowdata)
	ON_BN_CLICKED(IDC_BUTTON_SETING, &CWCHIOTTestDlg::OnBnClickedButtonSeting)
	ON_BN_CLICKED(IDC_BUTTON_GETVER, &CWCHIOTTestDlg::OnBnClickedButtonGetver)
	ON_BN_CLICKED(IDC_BUTTON_GETNATTYPE, &CWCHIOTTestDlg::OnBnClickedButtonGetnattype)
	ON_BN_CLICKED(IDC_BUTTON_GETCONNECTTYPE, &CWCHIOTTestDlg::OnBnClickedButtonGetconnecttype)
	ON_BN_CLICKED(IDC_BUTTON_REFRESHADAPTER, &CWCHIOTTestDlg::OnBnClickedButtonRefreshadapter)
	ON_BN_CLICKED(IDC_BUTTON_SCAN, &CWCHIOTTestDlg::OnBnClickedButtonScan)
	ON_CBN_SELCHANGE(IDC_NOWADAPTER, &CWCHIOTTestDlg::OnCbnSelchangeNowadapter)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_SETYZCODE, &CWCHIOTTestDlg::OnBnClickedButtonSetyzcode)
	ON_BN_CLICKED(IDC_BUTTON_GETYZCODE, &CWCHIOTTestDlg::OnBnClickedButtonGetyzcode)
	ON_BN_CLICKED(IDC_CHECK_cryptonym, &CWCHIOTTestDlg::OnBnClickedCheckcryptonym)
END_MESSAGE_MAP()


// CWCHIOTTestDlg 消息处理程序

BOOL CWCHIOTTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// 将“关于...”菜单项添加到系统菜单中。

	// IDM_ABOUTBOX 必须在系统命令范围内。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 设置此对话框的图标。当应用程序主窗口不是对话框时，框架将自动
	//  执行此操作
	SetIcon(m_hIcon, TRUE);			// 设置大图标
	SetIcon(m_hIcon, FALSE);		// 设置小图标

	// TODO: 在此添加额外的初始化代码
	if (IoCHub_Init() != 0) {
		MessageBox("初始化库失败");
	}

	IoCHub_RegisterEvent(pIochubEventCallBack);

	SetTimer(1, 1000, 0);  //
	SetTimer(2, 100, 0);  //

	OnBnClickedButtonRefreshadapter();

	m_combo_jurisdiction.AddString("公开");
	m_combo_jurisdiction.AddString("受限");
	m_combo_jurisdiction.AddString("私有");
	m_combo_jurisdiction.SetCurSel(0);

	((CButton*)GetDlgItem(IDC_CHECK_cryptonym))->SetCheck(1);
	GetDlgItem(IDC_EDIT_LOGINSECRECT)->EnableWindow(FALSE);

	SetDlgItemText(IDC_EDIT_TIMEOUT, "2000");
	SetDlgItemText(IDC_EDIT_CONNECTNUM, "10");
	SetDlgItemText(IDC_EDIT_BUFFSIZE, "10240000");
	SetDlgItemText(IDC_EDIT_RECVBUFFSIZE, "10240000");
	SetDlgItemText(IDC_EDIT_PACKETSIZE, "4096");
	SetDlgItemText(IDC_EDIT_SENDWND, "200");
	SetDlgItemText(IDC_EDIT_SENDWNDTIMEOUT, "100");
	((CButton*)GetDlgItem(IDC_CHECK_cryptonym))->SetCheck(1);
	GetDlgItem(IDC_EDIT_LOGINSECRECT)->EnableWindow(FALSE);

	//接触接收框显示字数限制
	SendDlgItemMessage(IDC_EDIT_RECVDATA, EM_LIMITTEXT, 0xFFFFFFFF, 0);


	return TRUE;  // 除非将焦点设置到控件，否则返回 TRUE
}

void CWCHIOTTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// 如果向对话框添加最小化按钮，则需要下面的代码
//  来绘制该图标。对于使用文档/视图模型的 MFC 应用程序，
//  这将由框架自动完成。

void CWCHIOTTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 用于绘制的设备上下文

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 使图标在工作区矩形中居中
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 绘制图标
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//当用户拖动最小化窗口时系统调用此函数取得光标
//显示。
HCURSOR CWCHIOTTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


DWORD WINAPI StartThread(LPVOID lpparam)
{
	CWCHIOTTestDlg* pDlg = (CWCHIOTTestDlg*)lpparam;
	char DevId[20] = "", TransBuf[20] = "", UserName[17] = "", UserSecret[9] = "", IPBuf[22] = "", ServerAddr[20] = "58.213.74.190:38089";
	int IDLen = 16, bRet = -1;

	if (((CButton*)pDlg->GetDlgItem(IDC_CHECK_cryptonym))->GetCheck() == 0) {
		pDlg->GetDlgItemText(IDC_EDIT_LOCALUK, UserName, 17);
		pDlg->GetDlgItemText(IDC_EDIT_LOGINSECRECT, UserSecret, 9);

		bRet = IoCHub_Start(ServerAddr, 2000, true);
		if (bRet == 0) {
			DbgPrint("启动服务成功\r\n");
			if (IoCHub_GetLocalID(DevId, &IDLen) == 0) {
				pDlg->SetDlgItemText(IDC_EDIT_LOCALUK, DevId);
			}
			pDlg->SetDlgItemText(IDC_BUTTON_LOGIN, "停止服务");
			if (IoCHub_GetNATType() == 0x00) {
				DbgPrint("本机网络类型为:非对称网络\r\n");
			}
			else {
				DbgPrint("本机网络类型为:对称网络\r\n");
			}
			g_OnlineStatus = 1;
		}
		else {
			DbgPrint("启动服务失败,错误码%d\r\n", bRet);
		}
	}
	else {
		bRet = IoCHub_Start(ServerAddr, 2000, true);
		if (bRet == 0) {
			DbgPrint("启动服务成功\r\n");
			if (IoCHub_GetLocalID(DevId, &IDLen) == 0) {
				pDlg->SetDlgItemText(IDC_EDIT_LOCALUK, DevId);
			}
			pDlg->SetDlgItemText(IDC_BUTTON_LOGIN, "停止服务");
			g_OnlineStatus = 1;
			if (IoCHub_GetNATType() == 0x00) {
				DbgPrint("本机网络类型为:非对称网络\r\n");
			}
			else {
				DbgPrint("本机网络类型为:对称网络\r\n");
			}
		}
		else {
			DbgPrint("启动服务失败,错误码%d\r\n", bRet);
		}
	}

	pDlg->GetDlgItem(IDC_BUTTON_LOGIN)->EnableWindow(TRUE);
	return 0;
}


void CWCHIOTTestDlg::OnBnClickedButtonLogin()
{
	// TODO: 在此添加控件通知处理程序代码
	char TransBuf[20] = "", UserName[17] = "", UserSecret[9] = "", IPBuf[22] = "", ServerAddr[20] = "58.213.74.190:38089", CfgFilePath[256] = "", CfgData[100] = "";
	int IDLen = 16, bRet = -1;
	FILE* CfgFile = NULL;

	if (!g_OnlineStatus) {
		GetDlgItem(IDC_BUTTON_LOGIN)->EnableWindow(FALSE);
		g_Synchronization = TRUE;
		bRet = IoCHub_Start(ServerAddr, 2000, g_Synchronization);
		if (!g_Synchronization)
			return;
		if (bRet == 0) {
			DbgPrint("启动服务成功\r\n");
			if (IoCHub_GetLocalID(g_LocalID, &IDLen) == 0) {
				SetDlgItemText(IDC_EDIT_LOCALUK, g_LocalID);
			}
			SetDlgItemText(IDC_BUTTON_LOGIN, "停止服务");
			g_OnlineStatus = 1;
			Sleep(1000);
			switch (IoCHub_GetNATType()) {
			case 0x00:
				DbgPrint("本机网络类型为:非对称网络\r\n");
				break;
			case 0x01:
				DbgPrint("本机网络类型为:全锥型\r\n");
				break;
			case 0x02:
				DbgPrint("本机网络类型为:IP受限锥型\r\n");
				break;
			case 0x03:
				DbgPrint("本机网络类型为:端口受限锥型\r\n");
				break;
			case 0x04:
				DbgPrint("本机网络类型为:具有固定IP地址\r\n");
				break;
			case 0x10:
				DbgPrint("本机网络类型为:对称NAT\r\n");
				break;
			case 0x11:
				DbgPrint("本机网络类型为:不支持UDP\r\n");
				break;
			case 0xFF:
				DbgPrint("本机网络类型为:未知类型\r\n");
				break;
			}
		}
		else {
			DbgPrint("启动服务失败,错误码%d\r\n", bRet);
		}
		GetDlgItem(IDC_BUTTON_LOGIN)->EnableWindow(TRUE);
	}
	else {
		IoCHub_Stop();

	}
}

DWORD WINAPI RecvThread(LPVOID lpparam)
{
	CWCHIOTTestDlg* pDlg = (CWCHIOTTestDlg*)lpparam;
	int RecvLen = 0;
	char RecvBuf[65550] = "";
	DWORD WriteLen = 0;

	while (ConnectHandle != -1) {
		memset(RecvBuf, 0, sizeof(RecvBuf));
		RecvLen = Session_Read(ConnectHandle, RecvBuf, 65535);
		if (RecvLen == 0) {
			Sleep(10);
		}
		else {
			if (g_ShowData) {
				SendDlgItemMessage(MainCwnd->m_hWnd, IDC_EDIT_RECVDATA, EM_SETSEL, 0xFFFFFFFE, 0xFFFFFFFE);
				SendDlgItemMessage(MainCwnd->m_hWnd, IDC_EDIT_RECVDATA, EM_REPLACESEL, 0, (LPARAM)RecvBuf);
				SendDlgItemMessage(MainCwnd->m_hWnd, IDC_EDIT_RECVDATA, EM_SETSEL, 0xFFFFFFFE, 0xFFFFFFFE);
			}
			if (g_SaveFileF) {
				SetFilePointer(g_SaveFile, g_SaveLen, 0, NULL);
				if (!WriteFile(g_SaveFile, RecvBuf, RecvLen, &WriteLen, NULL)) {   //向文件内写数据
					pDlg->MessageBox("写文件失败！");
					g_SaveFileF = FALSE;
				}
				g_SaveLen += RecvLen;
			}

			g_RecvNum += RecvLen;
			g_RecvSpeed += RecvLen;
			RecvLen = 0;
		}
	}
	return 0;
}

void CWCHIOTTestDlg::OnBnClickedButtonConnect()
{
	// TODO: 在此添加控件通知处理程序代码
	char TransBuf[20] = "", DevUK[9] = "", VerificationCode[9] = "", DevKey[9] = "", ErrorBuf[100] = "";
	GetDlgItemText(IDC_EDIT_CONNECTUK, TransBuf, 17);
	GetDlgItemText(IDC_EDIT_YZCODE, VerificationCode, 9);

	if (ConnectHandle < 0) {
		GetDlgItemText(IDC_EDIT_YZCODE, DevKey, 9);
		ConnectHandle = Session_Open(TransBuf, DevKey, 5000, true);
		if (ConnectHandle < 0) {
			sprintf(ErrorBuf, "打开会话失败,错误码%d", ConnectHandle);
			MessageBox(ErrorBuf);
		}
		else {
			SetDlgItemText(IDC_BUTTON_CONNECT, "关闭会话");
			CloseHandle(CreateThread(NULL, 0, RecvThread, this, 0, NULL)); //创建通信线程
		}
	}
	else {
		Session_Close(ConnectHandle);
		ConnectHandle = -1;
		SetDlgItemText(IDC_BUTTON_CONNECT, "打开会话");
	}
}

__int64 myFileSeek(HANDLE hf, __int64 distance, DWORD MoveMethod)
{
	LARGE_INTEGER li;

	li.QuadPart = distance;

	li.LowPart = SetFilePointer(hf,
		li.LowPart,
		&li.HighPart,
		MoveMethod);

	if (li.LowPart == INVALID_SET_FILE_POINTER && GetLastError()
		!= NO_ERROR)
	{
		li.QuadPart = -1;
	}

	return li.QuadPart;
}

DWORD WINAPI SendThread(LPVOID lpparam)
{
	CWCHIOTTestDlg* pDlg = (CWCHIOTTestDlg*)lpparam;
	char SendBuf[4097] = "", CopyBuf[4097] = "", ErrorBuf[100] = "";
	int SendLen = pDlg->m_edit_send.GetLength();
	int ErrorCode = 0, SentLen = 0;
	DWORD ReadLen = 0;
	long long SendFileLen = 0;

	strcpy(SendBuf, pDlg->m_edit_send);
	while (g_IsSending && ConnectHandle != NULL) {
	_SendData:
		SentLen = Session_Write(ConnectHandle, SendBuf, SendLen);
		if (SentLen < SendLen) {
			if (SentLen < 0) {
				if (SentLen == -401) {
					Sleep(1);
					goto _SendData;
				}
				else {
					sprintf(ErrorBuf, "发送出错,错误码%d", SentLen);
					MainCwnd->MessageBox(ErrorBuf);
					goto _End;
				}
			}
			else {
				g_SendNum += SentLen;
				g_SendSpeed += SentLen;

				SendLen -= SentLen;
				memset(CopyBuf, 0, sizeof(CopyBuf));
				memcpy(CopyBuf, &SendBuf[SentLen], SendLen);
				memset(SendBuf, 0, sizeof(SendBuf));
				memcpy(SendBuf, CopyBuf, SendLen);
				goto _SendData;
			}
		}
		else {
			g_SendNum += SentLen;
			g_SendSpeed += SentLen;
		}
		Sleep(g_InterTime);
	}

_End:
	g_IsSending = FALSE;
	MainCwnd->SetDlgItemText(IDC_BUTTON_SEND, " 发送数据 " );
	return 0;
}


void CWCHIOTTestDlg::OnBnClickedButtonSend()
{
	// TODO: 在此添加控件通知处理程序代码
	char SendBuf[4097] = "";
	CString Status;

	//发送数据
	if (ConnectHandle == NULL) {
		MessageBox(" 请先连接设备 ");
		return;
	}
	GetDlgItemText(IDC_BUTTON_SEND, Status);
	if (Status == " 停止发送 ") {
		g_IsSending = FALSE;
	}
	else {
		UpdateData(TRUE);
		if (((CButton*)GetDlgItem(IDC_CHECK_INTERTIME))->GetCheck() == 1) {
			g_IsSending = TRUE;
			g_InterTime = GetDlgItemInt(IDC_EDIT_INTERTIME);
			CloseHandle(CreateThread(NULL, 0, SendThread, this, 0, NULL));
			SetDlgItemText(IDC_BUTTON_SEND, " 停止发送 ");
		}
		else {
			strcpy(SendBuf, m_edit_send);
			Session_Write(ConnectHandle, SendBuf, m_edit_send.GetLength());
			g_SendNum += m_edit_send.GetLength();
			g_SendSpeed += m_edit_send.GetLength();
		}
	}
}

void CWCHIOTTestDlg::OnBnClickedButtonClrrecv()
{
	// TODO: 在此添加控件通知处理程序代码
	SetDlgItemText(IDC_EDIT_RECVDATA, "");
	SetDlgItemText(IDC_EDIT_SENDDATA, "");
	g_SendNum = 0;
	g_RecvNum = 0;
}

void CWCHIOTTestDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: 在此添加消息处理程序代码和/或调用默认值
	char TempBuf[20] = "";
	float SendSpeed = 0, RecvSpeed = 0;

	switch (nIDEvent) {
	case 1:
		SendSpeed = g_SendSpeed;
		RecvSpeed = g_RecvSpeed;
		g_SendSpeed = 0;
		g_RecvSpeed = 0;

		if (SendSpeed > 1024) {
			sprintf(TempBuf, "%.2fKb/s", SendSpeed / 1024);
		}
		else {
			sprintf(TempBuf, "%.2fb/s", SendSpeed);
		}
		SetDlgItemText(IDC_EDIT_SENDSPEED, TempBuf);


		if (RecvSpeed > 1024) {
			sprintf(TempBuf, "%.2fKb/s", RecvSpeed / 1024);
		}
		else {
			sprintf(TempBuf, "%.2fb/s", RecvSpeed);
		}
		SetDlgItemText(IDC_EDIT_RECVSPEED, TempBuf);
		break;
	case 2:
		sprintf(TempBuf, "%lldb", g_SendNum);
		SetDlgItemText(IDC_EDIT_SENDNUM, TempBuf);

		sprintf(TempBuf, "%lldb", g_RecvNum);
		SetDlgItemText(IDC_EDIT_RECVNUM, TempBuf);
		break;
	}

	CDialog::OnTimer(nIDEvent);
}

void CWCHIOTTestDlg::OnBnClickedCheckNotshowdata()
{
	// TODO: 在此添加控件通知处理程序代码
	if (((CButton*)GetDlgItem(IDC_CHECK_NOTSHOWDATA))->GetCheck() == 1) {
		g_ShowData = FALSE;
	}
	else {
		g_ShowData = TRUE;
	}
}

void CWCHIOTTestDlg::OnBnClickedButtonSeting()
{
	// TODO: 在此添加控件通知处理程序代码
	g_IotCfg.supportTLS = ((CButton*)GetDlgItem(IDC_CHECK_TLS))->GetCheck();
	g_IotCfg.supportDTLS = ((CButton*)GetDlgItem(IDC_CHECK_DTL))->GetCheck();
	g_IotCfg.supportCompress = ((CButton*)GetDlgItem(IDC_CHECK_COMPRESS))->GetCheck();
	g_IotCfg.maxConnSize = GetDlgItemInt(IDC_EDIT_CONNECTNUM);
	g_IotCfg.recvBufferSize = GetDlgItemInt(IDC_EDIT_RECVBUFFSIZE);
	g_IotCfg.sendBufferSize = GetDlgItemInt(IDC_EDIT_BUFFSIZE); 
	g_IotCfg.sendSizePerPackage = GetDlgItemInt(IDC_EDIT_PACKETSIZE);
	g_IotCfg.socketWndSize = GetDlgItemInt(IDC_EDIT_SENDWND);
	g_IotCfg.socketWndTimeout = GetDlgItemInt(IDC_EDIT_SENDWNDTIMEOUT);
	g_IotCfg.openDeviceLock = ((CButton*)GetDlgItem(IDC_CHECK_LOCK))->GetCheck();

	if (IoCHub_SetCfg(&g_IotCfg) == 0)
		MessageBox("设置配置参数成功!");
	else
		MessageBox("设置配置参数失败!");
}

void CWCHIOTTestDlg::OnBnClickedButtonGetver()
{
	// TODO: 在此添加控件通知处理程序代码
	char sdkVersion[10] = "";
	int VerLen = 0;

	IoCHub_GetSDKVersion(sdkVersion, &VerLen);
	if (VerLen != 0) {
		SetDlgItemText(IDC_EDIT_SDKVER, sdkVersion);
	}

}

/**
 *         0x00 //非对称类型
 *         0x01 //全锥型NAT
 *         0x02 //受限锥型NAT
 *         0x03 //端口受限型NAT
 *         0x04 //表示直接是公网IP没有经过NAT转换
 *		   0x10 //SYMMETRIC NAT 对称NAT
 *		   0x11 //不支持UDP连接(防火墙阻止UDP连接)
 *		   0xFF //未知类型(未登录检测)
				 */
void CWCHIOTTestDlg::OnBnClickedButtonGetnattype()
{
	// TODO: 在此添加控件通知处理程序代码
	switch (IoCHub_GetNATType()) {
	case 0x00:
		SetDlgItemText(IDC_EDIT_NATTYPE, " 非对称NAT ");
		break;
	case 0x01:
		SetDlgItemText(IDC_EDIT_NATTYPE, " 全锥型NAT ");
		break;
	case 0x02:
		SetDlgItemText(IDC_EDIT_NATTYPE, " 受限锥型NAT ");
		break;
	case 0x03:
		SetDlgItemText(IDC_EDIT_NATTYPE, " 端口受限型NAT ");
		break;
	case 0x04:
		SetDlgItemText(IDC_EDIT_NATTYPE, " 无NAT ");
		break;
	case 0x10:
		SetDlgItemText(IDC_EDIT_NATTYPE, " 对称NAT ");
		break;
	case 0x11:
		SetDlgItemText(IDC_EDIT_NATTYPE, " 不支持UDP ");
		break;
	case 0xFF:
		SetDlgItemText(IDC_EDIT_NATTYPE, " 未知类型 ");
		break;
	}
}

void CWCHIOTTestDlg::OnBnClickedButtonGetconnecttype()
{
	// TODO: 在此添加控件通知处理程序代码
	char Ret = Session_GetTransferType(ConnectHandle);
	switch (Ret) {
	case 0x00:
		SetDlgItemText(IDC_EDIT_CONNECTTYPE, " 未知 ");
		break;
	case 0x01:
		SetDlgItemText(IDC_EDIT_CONNECTTYPE, " P2P穿透 ");
		break;
	case 0x02: 
		SetDlgItemText(IDC_EDIT_CONNECTTYPE, " 服务转发 ");
		break;
	case 0x03:
		SetDlgItemText(IDC_EDIT_CONNECTTYPE, " 局域网 ");
		break;
	}

}

/****************************************************************                */
//
//	函数名: get_local
//
//	函数描述: 获得本机IP
//
//	参数:   PIP_ADAPTER_INFO node
//				
//	返回值: None
//
/****************************************************************                */
void get_local(PIP_ADAPTER_INFO node)
{
	memset(g_PCIP, 0, sizeof(g_PCIP));
	strcat(g_PCIP, node->IpAddressList.IpAddress.String);
}

/****************************************************************                */
//
//	函数名: get_adapter
//
//	函数描述: 搜索网卡
//
//	参数:   int index,BOOL init
//				
//	返回值: int
//
/****************************************************************                */
int CWCHIOTTestDlg::get_adapter(int index, BOOL init)
{
	PIP_ADAPTER_INFO padapter_info;
	PIP_ADAPTER_INFO padapter = NULL;
	DWORD ret_val = 0, i = 0;
	char tem_tr[128] = "";

	padapter_info = (IP_ADAPTER_INFO*)malloc(sizeof(IP_ADAPTER_INFO));
	ULONG out_buf_len = sizeof(IP_ADAPTER_INFO);

	if (GetAdaptersInfo(padapter_info, &out_buf_len) == ERROR_BUFFER_OVERFLOW) {

		free(padapter_info);
		padapter_info = (IP_ADAPTER_INFO*)malloc(out_buf_len);
	}

	if ((ret_val = GetAdaptersInfo(padapter_info, &out_buf_len)) == NO_ERROR) {

		padapter = padapter_info;
		while (padapter) {
			if ((padapter->Type == 71) || (padapter->Type == MIB_IF_TYPE_ETHERNET)) {
				i++;
				if (init) {

					sprintf(&tem_tr[0], "%d.%s\0", i, padapter->Description);
					((CComboBox*)GetDlgItem(IDC_NOWADAPTER))->AddString((LPCTSTR)tem_tr);
				}
				if ((int)i == index + 1) {
					get_local(padapter);
				}
			}
			padapter = padapter->Next;
		}
		if (init) {
			CString	str;
			((CComboBox*)GetDlgItem(IDC_NOWADAPTER))->SetCurSel(0);
			str.Format(_T("IP:%s "), g_PCIP);
		}
		return 0;
	}
	else {

		return -1;
	}
}

void CWCHIOTTestDlg::OnBnClickedButtonRefreshadapter()
{
	// TODO: 在此添加控件通知处理程序代码
	((CComboBox*)GetDlgItem(IDC_NOWADAPTER))->ResetContent();
	get_adapter(0, TRUE);
}

void CWCHIOTTestDlg::OnBnClickedButtonScan()
{
	// TODO: 在此添加控件通知处理程序代码
	int ScanNum = 0;
	char TempUK[100] = "";

	m_combo_scandev.ResetContent();

	ScanNum = IoCHub_ScanLanNodes(g_PCIP, 3000, pScanCallBack);
}

void CWCHIOTTestDlg::OnCbnSelchangeNowadapter()
{
	// TODO: 在此添加控件通知处理程序代码
	int index;
	CString	str;

	index = ((CComboBox*)GetDlgItem(IDC_NOWADAPTER))->GetCount();

	if (0 == index) {
		return;
	}
	memset(g_PCIP, 0, 16);

	index = ((CComboBox*)GetDlgItem(IDC_NOWADAPTER))->GetCurSel();

	get_adapter(index, FALSE);
	str.Format("IP:%s", g_PCIP);
}

void CWCHIOTTestDlg::OnClose()
{
	// TODO: 在此添加消息处理程序代码和/或调用默认值
	IoCHub_DeInit();

	CDialog::OnClose();
}

void CWCHIOTTestDlg::OnBnClickedButtonSetyzcode()
{
	// TODO: 在此添加控件通知处理程序代码
	int Authority = 0;
	char YZCode[9] = "";
	IOCHUB_ACCESS_MODE_T Mode;

	Mode.modeType = m_combo_jurisdiction.GetCurSel();
	GetDlgItemText(IDC_EDIT_LOCALCYCODE, YZCode, 9);
	Mode.sessionKey = YZCode;
	Mode.keySize = strlen(YZCode);
	if (IoCHub_SetAccessMode(&Mode) != 0)
		MessageBox("设置会话模式失败!");
	else
		MessageBox("设置会话模式成功!");
}

void CWCHIOTTestDlg::OnBnClickedButtonGetyzcode()
{
	// TODO: 在此添加控件通知处理程序代码
	int Authority = 0;
	char YZCode[9] = "";
	IOCHUB_ACCESS_MODE_T Mode;

	if (IoCHub_GetAccessMode(&Mode) == 0) {
		m_combo_jurisdiction.SetCurSel(Mode.modeType);
		SetDlgItemText(IDC_EDIT_LOCALCYCODE, Mode.sessionKey);
	}
	else {
		MessageBox("获取会话模式失败!");
	}
}

void CWCHIOTTestDlg::OnBnClickedCheckcryptonym()
{
	// TODO: 在此添加控件通知处理程序代码
	if (((CButton*)GetDlgItem(IDC_CHECK_cryptonym))->GetCheck() == 1) {
		GetDlgItem(IDC_EDIT_LOGINSECRECT)->EnableWindow(FALSE);
	}
	else {
		GetDlgItem(IDC_EDIT_LOGINSECRECT)->EnableWindow(TRUE);
	}
}
